/*
** ioctl.h - platform independent definitions for
** API-to-driver interface.
**
** NOTE: this file should not be included by applications.
**
** (C) Copyright 2000-2002 Alpha Data Parallel Systems Ltd.
*/

#if !defined(_ADATA_ADMXRC_IOCTL_H)
#define _ADATA_ADMXRC_IOCTL_H

#include "admxrc/status.h"
#include "admxrc/struct.h"
#include "admxrc2/status.h"
#include "admxrc2/struct.h"
#include "ioctl_platform.h"

typedef enum _ADMXRC_KEY_IOCTL_CODES		/* API rev first appearance */
{
  ADMXRC_KEY_IOCTL_SETCLOCK = ADMXRC_KEY_STARTIOCTL, /* apirev2 */
  ADMXRC_KEY_IOCTL_UNUSED1,
  ADMXRC_KEY_IOCTL_OPENCARD,                    /* apirev2 */
  ADMXRC_KEY_IOCTL_UNUSED2,
  ADMXRC_KEY_IOCTL_UNUSED3,
  ADMXRC_KEY_IOCTL_UNUSED4,
  ADMXRC_KEY_IOCTL_UNUSED5,
  ADMXRC_KEY_IOCTL_UNUSED6,
  ADMXRC_KEY_IOCTL_UNUSED7,
  ADMXRC_KEY_IOCTL_UNUSED8,
  ADMXRC_KEY_IOCTL_UNUSED9,
  ADMXRC_KEY_IOCTL_UNUSED10,
  ADMXRC_KEY_IOCTL_UNUSED11,
  ADMXRC_KEY_IOCTL_UNUSED12,
  ADMXRC_KEY_IOCTL_UNUSED13,
  ADMXRC_KEY_IOCTL_UNUSED14,
  ADMXRC_KEY_IOCTL_UNUSED15,
  ADMXRC_KEY_IOCTL_UNUSED16,
  ADMXRC_KEY_IOCTL_UNUSED17,
  ADMXRC_KEY_IOCTL_UNUSED18,
  ADMXRC_KEY_IOCTL_UNUSED19,
  ADMXRC_KEY_IOCTL_UNUSED20,
  ADMXRC_KEY_IOCTL_UNUSED21,
  ADMXRC_KEY_IOCTL_GETCARDINFO,                 /* apirev2 */
  ADMXRC_KEY_IOCTL_DODMA,                       /* apirev3 */
  ADMXRC_KEY_IOCTL_UNUSED22,
  ADMXRC_KEY_IOCTL_UNUSED23,
  ADMXRC_KEY_IOCTL_UNUSED24,
  ADMXRC_KEY_IOCTL_UNUSED25,
  ADMXRC_KEY_IOCTL_UNUSED26,
  ADMXRC_KEY_IOCTL_WRITEFLASH,                  /* apirev2 */
  ADMXRC_KEY_IOCTL_UNUSED27,
  ADMXRC_KEY_IOCTL_LOADFPGA,                    /* apirev2 */
  ADMXRC_KEY_IOCTL_WRITEREG,                    /* apirev2 */
  ADMXRC_KEY_IOCTL_READREG,                     /* apirev2 */
  ADMXRC_KEY_IOCTL_GETCLOCKTYPE,                /* apirev2 */
  ADMXRC_KEY_IOCTL_GETBASEADDRESS,              /* apirev2 */
  ADMXRC_KEY_IOCTL_WAITFORINTERRUPT,            /* apirev3 */
  ADMXRC_KEY_IOCTL_WRITE,                       /* apirev3 */
  ADMXRC_KEY_IOCTL_READ,                        /* apirev3 */
  ADMXRC_KEY_IOCTL_SETUPDMA,                    /* apirev3 */
  ADMXRC_KEY_IOCTL_UNSETUPDMA,                  /* apirev3 */
  ADMXRC_KEY_IOCTL_PROGRAMBYTES,                /* apirev3 (obsoletes _IOCTL_WRITEFLASH) */
  ADMXRC_KEY_IOCTL_REGINTERRUPTEVENT,           /* apirev3 */
  ADMXRC_KEY_IOCTL_UNREGINTERRUPTEVENT,         /* apirev3 */
  ADMXRC_KEY_IOCTL_GETVERSIONINFO,              /* apirev3 */
  ADMXRC_KEY_IOCTL_UNCONFIGUREFPGA,		/* apirev3 driver ver 2.5 - 3.0 */
  ADMXRC_KEY_IOCTL_CHECKFPGACONFIGURED,         /* apirev3 driver ver 2.5 - 3.0 */
  ADMXRC_KEY_IOCTL_MAPDIRECTMASTER,             /* apirev3 driver ver 2.8 */
  ADMXRC_KEY_IOCTL_SYNCDIRECTMASTER,            /* apirev3 driver ver 2.8 */
  ADMXRC2_KEY_IOCTL_GETCARDINFO,                /* apirev4 driver ver 3.0 */
  ADMXRC2_KEY_IOCTL_GETBANKINFO,                /* apirev4 driver ver 3.0 */
  ADMXRC2_KEY_IOCTL_OPENCARD,                   /* apirev4 driver ver 3.0 */
  ADMXRC2_KEY_IOCTL_SETCLOCK,                   /* apirev4 driver ver 3.0 */
  ADMXRC2_KEY_IOCTL_GETSPACEINFO,               /* apirev4 driver ver 3.0 */
  ADMXRC2_KEY_IOCTL_OPENCARDBYINDEX,            /* apirev4 driver ver 3.0 */
  ADMXRC2_KEY_IOCTL_READCONFIG,                 /* apirev4 driver ver 3.0 */
  ADMXRC2_KEY_IOCTL_WRITECONFIG,                /* apirev4 driver ver 3.0 */
  ADMXRC2_KEY_IOCTL_DODMAIMMEDIATE,             /* apirev4 driver ver 3.1 */
  ADMXRC2_KEY_IOCTL_LOADFPGADMA,                /* apirev4 driver ver 3.1 */
  ADMXRC2_KEY_IOCTL_CANCELWAITFORINTERRUPT      /* apirev4 driver ver 4.0 */
} ADMXRC_KEY_IOCTL_CODES;

#define ADMXRC_IOCTL_SETCLOCK              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETCLOCK,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_OPENCARD              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_OPENCARD,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITEFLASH            ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITEFLASH,          ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_LOADFPGA              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_LOADFPGA,            ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITEREG              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITEREG,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_READREG               ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READREG,             ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETCLOCKTYPE          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETCLOCKTYPE,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETBASEADDRESS        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETBASEADDRESS,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETCARDINFO           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETCARDINFO,         ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_DODMA                 ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_DODMA,               ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_WAITFORINTERRUPT      ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WAITFORINTERRUPT,    ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITE                 ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITE,               ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_READ                  ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READ,                ADMXRC_IOCTLF_MASS_READ,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_SETUPDMA              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETUPDMA,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_UNSETUPDMA            ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_UNSETUPDMA,          ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_PROGRAMBYTES          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_PROGRAMBYTES,        ADMXRC_IOCTLF_MASS_READWRITE, ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_REGINTERRUPTEVENT     ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_REGINTERRUPTEVENT,   ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_UNREGINTERRUPTEVENT   ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_UNREGINTERRUPTEVENT, ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETVERSIONINFO        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETVERSIONINFO,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_UNCONFIGUREFPGA       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_UNCONFIGUREFPGA,     ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_CHECKFPGACONFIGURED   ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_CHECKFPGACONFIGURED, ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_MAPDIRECTMASTER       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_MAPDIRECTMASTER,     ADMXRC_IOCTLF_MASS_READ,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_SYNCDIRECTMASTER      ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SYNCDIRECTMASTER,    ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC2_IOCTL_GETCARDINFO          ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_GETCARDINFO,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC2_IOCTL_GETBANKINFO          ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_GETBANKINFO,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC2_IOCTL_OPENCARD             ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_OPENCARD,           ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC2_IOCTL_SETCLOCK             ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_SETCLOCK,           ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC2_IOCTL_GETSPACEINFO         ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_GETSPACEINFO,       ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC2_IOCTL_OPENCARDBYINDEX      ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_OPENCARDBYINDEX,    ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC2_IOCTL_READCONFIG           ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_READCONFIG,         ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC2_IOCTL_WRITECONFIG          ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_WRITECONFIG,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_DODMAIMMEDIATE        ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_DODMAIMMEDIATE,     ADMXRC_IOCTLF_MASS_READWRITE, ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_LOADFPGADMA           ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_LOADFPGADMA,        ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_WAIT)
#define ADMXRC2_IOCTL_CANCELWAITFORINTERRUPT ADMXRC_MAKE_IOCTL(ADMXRC2_KEY_IOCTL_CANCELWAITFORINTERRUPT, ADMXRC_IOCTLF_MASS_NONE, ADMXRC_IOCTLF_NOWAIT)

/* Additional flags that can be added by driver wrapper */
#define ADMXRC_DMAFLAG_TIMEOUT (0x1 << 31)

typedef union _ADMXRC_IOCTLS_DODMA { 
  struct {
    ADMXRC2_DMADESC dmadesc;
    unsigned long   offset;
    unsigned long   length;
    unsigned long   local;
    unsigned long   direction;
    unsigned long   channel;
    unsigned long   mode;
    unsigned long   flags;
    unsigned long   timeout;
  } in;
} ADMXRC_IOCTLS_DODMA;

typedef union _ADMXRC_IOCTLS_DODMAIMMEDIATE
{
  struct {
    void*         buffer;
    unsigned long length;
    unsigned long local;
    unsigned long direction;
    unsigned long channel;
    unsigned long mode;
    unsigned long flags;
    unsigned long timeout;
  } in;
} ADMXRC_IOCTLS_DODMAIMMEDIATE;

typedef union _ADMXRC2_IOCTLS_GETBANKINFO {
  struct {
    unsigned long     index;
  } in;
  struct {
    ADMXRC2_BANK_INFO info;
  } out;
} ADMXRC2_IOCTLS_GETBANKINFO;

typedef union _ADMXRC_IOCTLS_GETCARDINFO {
  struct {
    ADMXRC_CARD_INFO info;
  } out;
} ADMXRC_IOCTLS_GETCARDINFO;

typedef union _ADMXRC2_IOCTLS_GETCARDINFO {
  struct {
    ADMXRC2_CARD_INFO info;
  } out;
} ADMXRC2_IOCTLS_GETCARDINFO;

typedef union _ADMXRC_IOCTLS_GETCLOCKTYPE {
  struct {
    unsigned long type;
  } out;
} ADMXRC_IOCTLS_GETCLOCKTYPE;

typedef union _ADMXRC2_IOCTLS_GETSPACEINFO {
  struct {
    unsigned long      index;
  } in;
  struct {
    ADMXRC2_SPACE_INFO info;
  } out;
} ADMXRC2_IOCTLS_GETSPACEINFO;

typedef union _ADMXRC_IOCTLS_GETVERSIONINFO {
  struct {
    unsigned char major;
    unsigned char minor;
  } out;
} ADMXRC_IOCTLS_GETVERSIONINFO;

typedef union _ADMXRC_IOCTLS_LOADFPGADMA {
  struct {
    unsigned long channel;
    unsigned long flags;
    void*         buffer;
    unsigned long length;
  } in;
} ADMXRC_IOCTLS_LOADFPGADMA;

typedef union _ADMXRC_IOCTLS_MAPDIRECTMASTER {
  struct {
    ADMXRC2_DMADESC dmadesc;
    unsigned long   offset;
    unsigned long   length;
    unsigned long   maxpage;
  } in;
  struct {
    unsigned long   pagelen;
    unsigned long   pagebits;
    unsigned long   pagespan;
    unsigned long   bytespan;
    unsigned long   initoffs;
  } out;
} ADMXRC_IOCTLS_MAPDIRECTMASTER;

typedef union _ADMXRC_IOCTLS_OPENCARD {
  struct {
    unsigned long card_id;
  } in;
} ADMXRC_IOCTLS_OPENCARD;

typedef union _ADMXRC2_IOCTLS_OPENCARD {
  struct {
    unsigned long card_id;
  } in;
} ADMXRC2_IOCTLS_OPENCARD;

typedef union _ADMXRC_IOCTLS_PROGRAMBYTES {
  struct {
    unsigned long length;
  } in;
} ADMXRC_IOCTLS_PROGRAMBYTES;

typedef union _ADMXRC_IOCTLS_READ
{
  struct {
    unsigned long width;
    unsigned long local;
    unsigned long flags;
  } in;
} ADMXRC_IOCTLS_READ;

typedef union _ADMXRC2_IOCTLS_READCONFIG {
  struct {
    unsigned long index;
  } in;
  struct {
    unsigned long value;
  } out;
} ADMXRC2_IOCTLS_READCONFIG;

typedef union _ADMXRC_IOCTLS_READREG {
  struct {
    unsigned char index;
  } in;
  struct {
    unsigned char value;
  } out;
} ADMXRC_IOCTLS_READREG;

typedef union _ADMXRC_IOCTLS_REGINTERRUPTEVENT {
  struct {
    ADMXRC2_EVENT event;
  } in;
} ADMXRC_IOCTLS_REGINTERRUPTEVENT;

typedef union _ADMXRC_IOCTLS_SETCLOCK {
  struct {
    unsigned long clockword;
  } in;
} ADMXRC_IOCTLS_SETCLOCK;

typedef union _ADMXRC2_IOCTLS_SETCLOCK {
  struct {
    unsigned long clock_index;
    unsigned long freq;
  } in;
  struct {
    unsigned long actual;
  } out;
} ADMXRC2_IOCTLS_SETCLOCK;

typedef union _ADMXRC_IOCTLS_SETUPDMA {
  struct {
    void*           buffer;
    unsigned long   size;
    unsigned long   flags;
  } in;
  struct {
    ADMXRC2_DMADESC dmadesc;
  } out;
} ADMXRC_IOCTLS_SETUPDMA;

typedef union _ADMXRC_IOCTLS_SYNCDIRECTMASTER {
  struct {
    ADMXRC2_DMADESC dmadesc;
    unsigned long   offset;
    unsigned long   length;
    unsigned long   syncmode;
  } in;
} ADMXRC_IOCTLS_SYNCDIRECTMASTER;

typedef union _ADMXRC_IOCTLS_UNREGINTERRUPTEVENT
{
  struct {
    ADMXRC2_EVENT event;
  } in;
} ADMXRC_IOCTLS_UNREGINTERRUPTEVENT;

typedef union _ADMXRC_IOCTLS_UNSETUPDMA {
  struct {
    ADMXRC2_DMADESC dmadesc;
  } in;
} ADMXRC_IOCTLS_UNSETUPDMA;

/* Additional flags that can be added by driver wrapper */
#define ADMXRC_INTWAIT_TIMEOUT (0x1 << 31)

typedef union _ADMXRC_IOCTLS_WAITFORINTERRUPT {
  struct {
    unsigned long timeout_us;
    unsigned long flags;
  } in;
  struct {
    unsigned long remaining_us;
    int           expired;
  } out;
} ADMXRC_IOCTLS_WAITFORINTERRUPT;

typedef union _ADMXRC_IOCTLS_WRITE
{
  struct {
    unsigned long width;
    unsigned long local;
    unsigned long flags;
  } in;
} ADMXRC_IOCTLS_WRITE;

typedef union _ADMXRC2_IOCTLS_WRITECONFIG {
  struct {
    unsigned long signature1;
    unsigned long index;
    unsigned long value;
    unsigned long signature2;
  } in;
} ADMXRC2_IOCTLS_WRITECONFIG;

typedef union _ADMXRC_IOCTLS_WRITEREG {
  struct {
    unsigned char index;
    unsigned char value;
  } in;
} ADMXRC_IOCTLS_WRITEREG;

#endif
